#!/bin/bash

echo $GREEN
echo "                   -- Script designed by kneda --"
echo
echo "                        Wireless Access Point"
echo
echo

## Desactiva la tarjeta de red ##
echo $GREEN
echo "   Desactivando tarjeta de red..."
ifconfig wlan1 down
sleep 1
echo $YELLOW
echo "     Completado!"
sleep 1

## Cambia la dirección MAC del adaptador de red ##
echo $GREEN
echo "   Cambiando dirección MAC..."
macchanger -A wlan1
macchanger -A wlan1
sleep 1
echo $YELLOW
echo "     Completado!"
sleep 1

## Activa el modo monitor ##
echo $GREEN
echo "   Activando modo monitor..."
iwconfig wlan1 mode monitor
sleep 1
echo $YELLOW
echo "     Completado!"
sleep 1

## Activa la tarjeta de red ##
echo $GREEN
echo "   Activando tarjeta de red..."
ifconfig wlan1 up
sleep 1
echo $YELLOW
echo "     Completado!"
sleep 1

## Crea un AP que va a transmitir por el canal 10 con el SSID Wi-Fi_gratis en el adaptador de red que está puesto en modo monitor ##
echo $GREEN
echo "   Creando punto de acceso (Wi-Fi_gratis)..."
xterm -fg green -geometry 150x35-1+0 -T "Wi-Fi_gratis" -e "airbase-ng -c 10 -e Wi-Fi_gratis wlan1" &
sleep 1
echo $YELLOW
echo "     Completado!"
sleep 1

## Establece una dirección IP y una máscara de red en at0 creada por airbase ##
echo $GREEN
echo "   Configurando at0..."
ifconfig at0 192.168.2.1 netmask 255.255.255.0 &
sleep 1
echo $YELLOW
echo "     Completado!"
sleep 1

## Cambiando parametros a la unidad de transmisión máxima ##
echo $GREEN
echo "   Cambiando parametros a mtu..."
ifconfig at0 mtu 1400 &
sleep 1
echo $YELLOW
echo "     Completado!"
sleep 1

## Modificando tabla de enrutamiento ##
echo $GREEN
echo "   Modificando tabla de enrutamiento..."
route add -net 192.168.2.0 netmask 255.255.255.0 gw 192.168.2.1 &
sleep 1
echo $YELLOW
echo "     Completado!"
sleep 1

## Activa ip_forward ##
echo $GREEN
echo "   Activando ip_forward..."
echo 1 > /proc/sys/net/ipv4/ip_forward &
sleep 1
echo $YELLOW
echo "     Completado!"
sleep 1

## Limpiando todas las reglas activas que pudiera haber ##
echo $GREEN
echo "   Limpieza de reglas iptables antes de la configuración..."
iptables --flush
sleep 1
echo $YELLOW
echo "     Completado!"
sleep 1

## Configuración de iptables ##
echo $GREEN
echo "   Configurando iptables..."
iptables -t nat -A PREROUTING -p udp -j DNAT --to 192.168.1.1
iptables -P FORWARD ACCEPT
iptables -A FORWARD -i at0 -j ACCEPT
iptables -t nat -A POSTROUTING -o wlan2 -j MASQUERADE
sleep 1
echo $YELLOW
echo "     Completado!"
sleep 1

## Cogiendo documento dhcpd.conf y creando dhcpd.pid ##
echo $GREEN
echo "   Leyendo documento dhcpd.conf y creando el documento identificador de procesos..."
dhcpd -cf /root/dhcp/dhcpd.conf -pf /var/run/dhcpd.pid at0 &
sleep 1
echo $YELLOW
echo "     Completado!"
sleep 1

## Iniciando el servidor dhcp ##
echo $GREEN
echo "   Iniciando el servidor dhcp..."
/etc/init.d/isc-dhcp-server start &
sleep 1
echo $YELLOW
echo "     Completado!"
sleep 1

## Happy hacking ##
echo $GREEN
echo
echo "     ##->  HAPPY HACKING  <-##"
echo

exit
